Difference between revisions of "Python scripting tutorial/fr"

From FreeCAD Documentation
Jump to navigation Jump to search
Line 171: Line 171:
 
[https://fr.wikipedia.org/wiki/Mesh_(objet) Un Maillage] est un type d'objet 3D très simple, utilisé par exemple par [https://fr.wikipedia.org/wiki/SketchUp Sketchup], [https://fr.wikipedia.org/wiki/Blender Blender] et [https://fr.wikipedia.org/wiki/Autodesk_3ds_Max 3D Studio Max]. Ils sont composés de 3 éléments : des points (également appelés sommets), des lignes (également appelées arêtes) et des faces. Dans de nombreuses applications, FreeCAD inclus, les faces peuvent n'avoir que 3 sommets. Bien sûr, rien ne vous empêche d'avoir une face plus grande composée de plusieurs triangles coplanaires.
 
[https://fr.wikipedia.org/wiki/Mesh_(objet) Un Maillage] est un type d'objet 3D très simple, utilisé par exemple par [https://fr.wikipedia.org/wiki/SketchUp Sketchup], [https://fr.wikipedia.org/wiki/Blender Blender] et [https://fr.wikipedia.org/wiki/Autodesk_3ds_Max 3D Studio Max]. Ils sont composés de 3 éléments : des points (également appelés sommets), des lignes (également appelées arêtes) et des faces. Dans de nombreuses applications, FreeCAD inclus, les faces peuvent n'avoir que 3 sommets. Bien sûr, rien ne vous empêche d'avoir une face plus grande composée de plusieurs triangles coplanaires.
  
<div class="mw-translate-fuzzy">
+
Les maillages sont simples, mais comme ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont moins utilisés et sont principalement là pour que vous puissiez importer des objets dans des formats de maillage ({{FileName|.stl}}, {{FileName|.obj}}) à partir d'autres applications. Le module Mesh a également été largement utilisé comme module de test principal au cours du premier mois de la vie de FreeCAD.
Les maillages sont simples, mais parce qu'ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont peu utilisés et la plupart du temps vous pouvez donc importer des objets au format de maillage (.stl, .obj) à partir d’autres applications. Le module Mesh a également été largement utilisé comme module de test principal au départ du développement de FreeCAD.
 
</div>
 
  
 
L'objet '''Mesh''' et l'objet '''FreeCAD''' sont deux choses totalement différentes. Vous pouvez voir l'objet FreeCAD '''comme conteneur''' d'un Objet Mesh (nous le verrons ci-dessous avec les Objets Part). <br />
 
L'objet '''Mesh''' et l'objet '''FreeCAD''' sont deux choses totalement différentes. Vous pouvez voir l'objet FreeCAD '''comme conteneur''' d'un Objet Mesh (nous le verrons ci-dessous avec les Objets Part). <br />

Revision as of 20:06, 29 May 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎čeština • ‎русский • ‎中文(中国大陆)‎ • ‎日本語
Arrow-left.svg Page précédente : Introduction au langage Python
Page suivante : Débuter avec les scripts Arrow-right.svg

Introduction

Python est un langage de programmation qui est relativement facile à apprendre et à comprendre. Il est open-source et multi-plateforme et peut être utilisé à de nombreuses fins : des scripts shell simples aux programmes très complexes. Mais son utilisation la plus répandue se trouve dans le langage de script intégré dans d'autres applications. C'est ainsi qu'il est utilisé dans FreeCAD. Depuis la console Python, ou depuis des scripts personnalisés, vous pouvez contrôler FreeCAD et lui faire effectuer des opérations très complexes.

Par exemple, à partir d'un script Python, vous pouvez :

  • Créer de nouveaux objets.
  • Modifier les objets existants.
  • Modifier la représentation 3D de ces objets.
  • Modifier l'interface de FreeCAD.

Il existe plusieurs façons d'utiliser Python dans FreeCAD :

  • Depuis l'interpréteur Python de FreeCAD, où vous pouvez exécuter du code dans une interface du style " ligne de commande ".
  • Depuis les macros, qui sont un moyen pratique d'ajouter rapidement un outil manquant à l'interface FreeCAD.
  • A partir de scripts externes, qui peuvent être utilisés pour créer des solutions assez complexes, même des Ateliers entiers.

Dans ce tutoriel, nous allons travailler sur quelques exemples de base pour vous aider à démarrer, mais il y a beaucoup plus de documentations sur les scripts Python disponibles sur ce wiki. Si vous êtes totalement nouveau sur Python et que vous voulez comprendre comment cela fonctionne, nous avons également une Introduction à Python.

Avant de continuer avec les scripts Python, allez dans la fenêtre Edit → Préférences → Général → Fenêtre de sortie et cochez les deux cases :

  • Rediriger les messages internes Python vers la vue rapport.
  • Rediriger les erreurs internes de Python vers la vue rapport.

Accédez ensuite à Affichage → Panneau et vérifiez :

  • Vue de rapport coché.

Ecrire du code Python

Il existe deux façons d'écrire du code Python dans FreeCAD. Dans la Console Python (sélectionnez le menuAffichage → Panneau → Console Python) ou dans l'éditeur de Macro (sélectionnez Macro → Macros … dans le menu). Dans la console vous écrivez les commandes Python une par une, en les exécutant en appuyant sur Entrée, tandis que les macros peuvent contenir du code plus complexe composé de plusieurs lignes, exécuté uniquement lorsque la macro est démarrée.

Screenshot pythoninterpreter.jpg

La console Python FreeCAD


Dans ce tutoriel vous pouvez utiliser les deux méthodes. Vous pouvez copier-coller chaque ligne dans la console Python puis appuyer sur Entrée, ou copier-coller le code entier dans une nouvelle fenêtre Macro.

En haut

Exploration de FreeCAD

Commençons par créer un nouveau document vierge :

doc = FreeCAD.newDocument()

Si vous écrivez dans la console Python FreeCAD, vous remarquerez que dès que vous tapez FreeCAD. une fenêtre apparaît, permettant de compléter rapidement le reste de votre ligne. Encore mieux, chaque entrée de la liste de saisie semi-automatique a une info-bulle expliquant ce qu'elle fait. Cela facilite l'exploration des fonctionnalités disponibles. Avant de choisir newDocument, jetez un œil aux autres options.

Screenshot classbrowser.jpg

Le mécanisme de saisie semi-automatique de la console Python FreeCAD


Maintenant notre nouveau document sera créé. Cela revient à appuyer sur le bouton Std New.svg Std New dans la barre d'outils. En fait, la plupart des boutons de FreeCAD ne font rien d'autre que d'exécuter une ou plusieurs lignes de code Python. Encore mieux, vous pouvez définir une option dans Édition → Préférences → Général → Macro avec Montrer les commandes du script dans la console Python. Cela affichera dans la console tout le code Python exécuté lorsque vous pressez les boutons. Très utile pour apprendre à reproduire des actions dans Python.

Maintenant revenons à notre document et voyons ce que nous pouvons faire avec lui :

doc.

Explorez les options disponibles. Habituellement, les noms qui commencent par une majuscule sont des attributs, ils contiennent une valeur, tandis que les noms qui commencent par une minuscule sont des fonctions (également appelées méthodes) ; ils "font quelque chose". Les noms commençant par un trait de soulignement sont généralement là pour le fonctionnement interne du module et vous ne devriez pas vous en soucier. Utilisons l'une des méthodes pour ajouter un nouvel objet à notre document :

box = doc.addObject("Part::Box", "myBox")

Rien ne se passe. Pourquoi ? Parce que FreeCAD est conçu pour de gros projets. Un jour, il fonctionnera avec des centaines d'objets complexes, tous dépendants les uns des autres. Faire un petit changement quelque part pourrait avoir un grand impact, vous devrez peut-être recalculer tout le document, ce qui pourrait prendre du temps. Pour cette raison, presque aucune commande ne met automatiquement à jour la scène. Vous devez le faire manuellement :

doc.recompute()

Maintenant notre boîte est apparue. De nombreux boutons qui ajoutent des objets dans FreeCAD font en fait deux choses : ajouter l'objet et recalculer. Si vous avez activé l'option Montrer les commandes du script dans la console Python ci-dessus, essayez d'ajouter une sphère avec le bouton GUI, vous verrez les deux lignes de code Python s'exécuter l'une après l'autre.

Explorons maintenant le contenu de notre boîte :

box.

Vous verrez immédiatement un certain nombre de choses très intéressantes telles que :

box.Height

Cela affichera la hauteur actuelle de notre boîte. Maintenant, essayons de changer cela :

box.Height = 5

Si vous sélectionnez votre boîte avec la souris, vous verrez que dans l'Éditeur de propriétés, sous l'onglet Données, notre propriété DonnéesHauteur apparaît. Toutes les propriétés d'un objet FreeCAD qui y apparaissent (et également sur l'onglet Vue, nous développerons plus tard), sont également directement accessibles par Python, par leur nom, comme nous l'avons fait avec notre propriété DonnéesHauteur. Essayez de changer les autres dimensions de la boîte.

En haut

Vecteurs et placements

Les vecteurs sont un concept tout à fait fondamental dans toute application 3D. Un vecteur est une liste de 3 nombres (x, y et z), décrivant un point ou une position dans l'espace 3D. Beaucoup de choses peuvent être faites avec des vecteurs, tels que des additions, des soustractions, des projections et beaucoup plus. Dans FreeCAD, les vecteurs fonctionnent comme ceci :

myvec = FreeCAD.Vector(2, 0, 0)
myvec.x
myvec.y
othervec = FreeCAD.Vector(0, 3, 0)
sumvec = myvec.add(othervec)

Une autre caractéristique commune des objets FreeCAD est leur placement. Chaque objet possède une propriété DonnéesPlacement, qui contient les DonnéesBase (position) et les DonnéesRotation (orientation) de l'objet. Elle est facile à manipuler, par exemple pour déplacer notre objet :

box.Placement
box.Placement.Base
box.Placement.Base = sumvec
 
otherpla = FreeCAD.Placement()
box.Placement = otherpla

Avant d'aller plus loin, vous devez comprendre quelques concepts importants.

En haut

Application et Interface Utilisateur

FreeCAD a été conçu pour pouvoir également être utilisé sans son interface utilisateur, en tant qu'application en ligne de commande. Presque chaque objet dans FreeCAD se compose donc de deux parties : un Object (objet), sa composante "géométrie" et un ViewObject (Vue de l'objet), sa composante "visuelle". Lorsque vous travaillez en mode ligne de commande, la partie géométrique est présente, mais la partie visuelle est désactivée.

Pour illustrer le concept, observons notre objet cube. Les propriétés géométriques du cube, telles que ses dimensions, sa position, etc. sont stockées dans Object. Alors que ses propriétés visuelles, telles que sa couleur, son épaisseur de ligne, etc. sont stockées dans ViewObject. Cela correspond aux onglets Données et Vue dans l'Éditeur de propriétés. La partie ViewObject d'un objet est accessible comme ceci :

vo = box.ViewObject

Vous pouvez également modifier les propriétés de l'onglet Vue :

vo.Transparency = 80
vo.hide()
vo.show()

Lorsque vous démarrez FreeCAD, la console Python charge déjà deux modules de base : FreeCAD et FreeCADGui (qui sont également accessibles par leurs raccourcis App et Gui). Ils contiennent toutes sortes de fonctionnalités génériques pour travailler avec des documents et leurs objets. Pour illustrer notre concept, voyez que FreeCAD et FreeCADGui contiennent à la fois un attribut ActiveDocument, qui est le document actuellement ouvert. FreeCAD.ActiveDocument et FreeCADGui.ActiveDocument ne sont cependant pas le même objet. Ce sont les deux composants d'un document FreeCAD et ils contiennent différents attributs et méthodes. Par exemple, FreeCADGui.ActiveDocument contient ActiveView, qui est la Vue 3D actuellement ouverte.

En haut

Les modules

La véritable puissance de FreeCAD réside dans ses précieux modules. L'application de base FreeCAD est plus ou moins un conteneur vide. Sans ses modules, elle ne peut guère faire plus que créer de nouveaux documents vides. Chaque module ajoute non seulement de nouveaux ateliers à l'interface, mais également de nouvelles commandes Python et de nouveaux types d'objets. Par conséquent, plusieurs types d'objets différents, voire totalement incompatibles, peuvent coexister dans le même document. Les modules les plus importants de FreeCAD que nous verrons dans ce tutoriel sont : Part (Pièce), Mesh (Maillage), Sketcher (Esquisse) et Draft (Planche à dessin).

Sketcher (Atelier Esquisse) et Draft (Atelier Planche à dessin) utilisent tous deux le module Part (Atelier Pièce) pour créer et gérer leur géométrie. Tandis que Mesh (Atelier Maillage) est totalement indépendant et gère ses propres objets. Plus d'informations à ce sujet ci-dessous.

Vous pouvez vérifier tous les types d'objets de base disponibles pour le document actuel comme ceci :

doc.supportedTypes()

Les différents modules FreeCAD ne sont pas automatiquement chargés dans la console Python. C'est pour éviter d'avoir un démarrage très lent. Les modules sont chargés uniquement lorsque vous en avez besoin. Ainsi, par exemple, pour explorer ce qui se trouve à l'intérieur du module Part :

import Part
Part.

Mais nous parlerons plus en détail du module Part ci-dessous.

En haut

Mesh (Maillage)

Un Maillage est un type d'objet 3D très simple, utilisé par exemple par Sketchup, Blender et 3D Studio Max. Ils sont composés de 3 éléments : des points (également appelés sommets), des lignes (également appelées arêtes) et des faces. Dans de nombreuses applications, FreeCAD inclus, les faces peuvent n'avoir que 3 sommets. Bien sûr, rien ne vous empêche d'avoir une face plus grande composée de plusieurs triangles coplanaires.

Les maillages sont simples, mais comme ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont moins utilisés et sont principalement là pour que vous puissiez importer des objets dans des formats de maillage (.stl, .obj) à partir d'autres applications. Le module Mesh a également été largement utilisé comme module de test principal au cours du premier mois de la vie de FreeCAD.

L'objet Mesh et l'objet FreeCAD sont deux choses totalement différentes. Vous pouvez voir l'objet FreeCAD comme conteneur d'un Objet Mesh (nous le verrons ci-dessous avec les Objets Part).
Ainsi, afin d'ajouter un Objet Mesh à FreeCAD, nous devons d'abord créer un Objet FreeCAD, créer un Objet Mesh et ensuite ajouter l'Objet Mesh à l'Objet FreeCAD:

import Mesh
mymesh = Mesh.createSphere()
mymesh.Facets
mymesh.Points
 
meshobj = doc.addObject("Mesh::Feature", "MyMesh")
meshobj.Mesh = mymesh
doc.recompute()

Il s'agit ici d'un exemple classique, qui utilise la méthode createSphere() pour créer automatiquement une sphère mais vous pouvez très bien créer des maillages personnalisés à partir de rien, en définissant leurs sommets et leurs faces.

Ici plus de renseignements sur les scripts Mesh ...

top

Part (Boîte à outils)

La boîte à outils est le module le plus puissant de l'ensemble FreeCAD. Il permet de créer et de manipuler des objets B-Rep. Ce type d'objet, contrairement à Mesh, peut avoir une grande variété de composantes. Pour mémoire, B-rep qui signifie boundary representation, ce qui signifie en français Représentation par les Bords ou modélisation surfacique. Ces surfaces peuvent être une grande variété d'objets, tel que des surfaces planes ou des surfaces très complexes NURBS (pour Non-Uniform Rational Basis Splines). Ils contribuent également à la notion de volume.

The Part Module is the most powerful module in the whole of FreeCAD. It allows you to create and manipulate BRep objects. BRep stands for "Boundary Representation". A BRep object is defined by surfaces that enclose and define an inner volume. Unlike meshes, BRep objects can have a wide variety of components from planar faces to very complex NURBS surfaces.

La Boîte à outils est basée sur la puissante bibliothèque OpenCascade, qui permet un large éventail d'opérations complexes, qui peuvent être facilement effectuées sur ces objets, tels que, les opérations booléennes, le filetage, balayage, etc ..

Le module fonctionne en partie de la même manière que le module Mesh:
Vous créez un Objet FreeCAD puis un Objet Part et après, ajoutez l'Objet Part à l'Objet FreeCAD:

import Part
myshape = Part.makeSphere(10)
myshape.Volume
myshape.Area

shapeobj = doc.addObject("Part::Feature", "MyShape")
shapeobj.Shape = myshape
doc.recompute()

Le module Part (tout comme le module Mesh) dispose également d'un raccourci qui crée automatiquement un Objet dans FreeCAD et lui ajoute une forme, vous pouvez ainsi sauter les 3 dernières lignes ci-dessus:

Part.show(myshape)

En explorant le contenu de myShape. dans la fenêtre, vous remarquerez de nombreuses et intéressantes options disponibles comme Faces, Edges, Vertexes, Solids ou Shells et un large éventail d'opérations géométriques telles soustraction, intersection ou union. La page Script pour les pièces explique tout cela en détail.

top

Draft (projet de dessin)

FreeCAD propose de nombreux autres modules, tels que Atelier sketcher(esquisse) et Atelier draft (projet) qui créent également des objets Pièce. Ces modules ajoutent des paramètres supplémentaires aux objets créés voire implémentent une toute nouvelle façon de gérer la géométrie de la pièce qu'ils contiennent. Notre exemple de boîte ci-dessus est un exemple parfait d'objet paramétrique. Pour définir cette zone, il vous suffit de spécifier les paramètres hauteur, largeur et longueur. Sur cette base, l’objet calculera automatiquement la forme de sa partie. FreeCAD vous permet de Objets créés par script.

FreeCAD features many more modules, such as Sketcher and Draft, that also create Part objects. These modules add additional parameters to the objects created, or even implement a whole new way to handle the Part geometry in them. Our box example above is a perfect example of a parametric object. All you need to define the box is to specify the parameters height, width and length. Based on those, the object will automatically calculate its Part shape. FreeCAD allows you to create such objects in Python.

Le Module Draft ajoute une série d'objets de types 2D paramétriques (qui sont tous des objets Part) tels que les lignes et les cercles, et fournit également quelques fonctions génériques qui ne travaillent pas seulement sur ​​les objets fabriqués, mais sur n'importe quel objet Part.
Pour voir ce qui est disponible, il suffit de faire:

import Draft
rec = Draft.makeRectangle(5, 2)
mvec = FreeCAD.Vector(4, 4, 0)
Draft.move(rec, mvec)
Draft.move(box, mvec)

top

Interface

L'interface utilisateur (Gui) de FreeCAD est faite avec Qt, un puissant système de création d'interface visuelle graphique, chargé de construire et de gérer, commandes, menus, barres d'outils, boutons 3D ... Qt fournit un module appelé PySide (en) qui permet à Python d'accéder et de modifier les interfaces contruites avec Qt, comme FreeCAD.
Essayons de travailler avec l'interface Qt et de construire une simple boîte de dialogue:

The FreeCAD user interface is made with Qt, a powerful graphical interface system, responsible for drawing and handling all the controls, menus, toolbars and buttons around the 3D view. Qt provides a module, PySide, which allows Python to access and modify Qt interfaces such as FreeCAD's. Let's try to fiddle with the Qt interface and produce a simple dialog:

from PySide import QtGui
QtGui.QMessageBox.information(None, "Apollo program", "Houston, we have a problem")

Une boîte de dialogue apparaît et nous voyons aussi l'icone de FreeCAD, ce qui signifie que Qt sait que l'ordre d'affichage de la fenêtre a été fait à l'intérieur de l'application FreeCAD. Nous pouvons donc facilement et partiellement modifier l'interface de FreeCAD.

Qt est un système de construction d'interface très puissant qui vous permet de faire des choses très complexes. Qt possède aussi une panoplie d'outils tel que Qt Designer avec lequel vous pouvez concevoir vos boîtes de dialogue graphique et de les ajouter à l'interface de FreeCAD avec quelques lignes de code Python.

Plus de renseignements sur PyQt ici et ici PyQt

top

Macros

Maintenant que vous avez une bonne connaissance des notions de base, où allons-nous placer nos scripts Python ? Comment allons-nous les lancer à partir de FreeCAD?
Il y a pour cela un mécanisme appelé Macros. Une macro est tout simplement un script en Python qui peut être ensuite ajouté à la barre d'outils et lancé à partir d'un simple clic de souris.
FreeCAD est fournit avec un petit éditeur de texte (Macro → Macros → Créer) où vous pouvez écrire ou coller des scripts. Une fois le script terminé, allez dans Outils → Personnaliser → Macros où vous pouvez définir un bouton pour votre macro puis ajouter ce bouton à la barre d'outils.

Now that you have a good understanding of the basics, where are we going to keep our Python scripts, and how are we going to launch them inside FreeCAD? There is an easy mechanism for that, called Macros. A macro is a Python script that can be added to a toolbar and launched via a mouse click. FreeCAD provides you with a simple text editor (Macro → Macros... → Create) where you can write or paste scripts. Once the script is done, use Tools → Customize... → Macros to define a button for it that can be added to toolbars.

Vous êtes maintenant prêt pour un script FreeCAD plus approfondi. Rendez-vous sur la Documentation pour utilisateurs avancés!

top

Arrow-left.svg Page précédente : Introduction to Python
Page suivante : FreeCAD Scripting Basics Arrow-right.svg